#ifndef _LIBNFXT_PROPS_H
#define _LIBNFXT_PROPS_H 1

#if defined(__cplusplus) && __cplusplus >= 201100L
#	include <cstdint>
#	include <cstdio>
#else
#	include <stdint.h>
#	include <stdio.h>
#endif
#include <libnetfilter_xtables/xtnetlink.h>
#include <libnetfilter_xtables/xtuser.h>

#ifdef __cplusplus
extern "C" {
#endif

#define __xtuser_aprop(name, rtype, deflt, key) \
	static inline rtype \
	xtuser_actionprop_##name(const struct xtuser_action *action) \
	{ \
		rtype x = (deflt); \
		xtuser_action_propget(action, (key), &x); \
		return x; \
	}
#define __xtuser_cprop(name, rtype, deflt, key) \
	static inline rtype \
	xtuser_chainprop_##name(const struct xtuser_chain *chain) \
	{ \
		rtype x = (deflt); \
		xtuser_chain_propget(chain, (key), &x); \
		return x; \
	}
#define __xtuser_iprop(name, rtype, deflt, key) \
	static inline rtype \
	xtnetlink_identprop_##name(const struct xtnetlink_identify *idp) \
	{ \
		rtype x = (deflt); \
		xtnetlink_ident_propget(idp, (key), &x); \
		return x; \
	}

__xtuser_aprop(type, enum xtuser_action_type, XTUSER_ACTION_NONE, XTUSER_APROP_TYPE);
__xtuser_aprop(verdict, unsigned int, ~0U, XTUSER_APROP_VERDICT);
__xtuser_aprop(name, const char *, NULL, XTUSER_APROP_NAME);
__xtuser_aprop(revision, unsigned int, ~0U, XTUSER_APROP_REVISION);
__xtuser_aprop(data, void *, NULL, XTUSER_APROP_DATA);
__xtuser_aprop(dsize, size_t, 0, XTUSER_APROP_DATASIZE);
__xtuser_cprop(name, const char *, NULL, XTUSER_CPROP_NAME);
__xtuser_cprop(hooknum, unsigned int, XTUSER_INVALID_HOOK, XTUSER_CPROP_HOOKNUM);
__xtuser_cprop(hookprio, int, 0, XTUSER_CPROP_HOOKPRIO);
__xtuser_cprop(hooknfproto, uint8_t, XTUSER_INVALID_NFPROTO, XTUSER_CPROP_HOOKNFPROTO);
__xtuser_iprop(impname, const char *, NULL, XTNETLINK_IDPROP_IMPNAME);
__xtuser_iprop(revmin, unsigned int, -1, XTNETLINK_IDPROP_REVMIN);
__xtuser_iprop(revmax, unsigned int, -1, XTNETLINK_IDPROP_REVMAX);

#undef __xtuser_aprop
#undef __xtuser_cprop
#undef __xtuser_iprop

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* _LIBNFXT_PROPS_H */
